package com.company.test.data_store

import io.jmix.core.DataStore
import io.jmix.core.LoadContext
import io.jmix.core.SaveContext
import io.jmix.core.ValueLoadContext
import io.jmix.core.entity.KeyValueEntity
import org.springframework.beans.factory.config.BeanDefinition
import org.springframework.context.annotation.Scope
import org.springframework.stereotype.Component

@Component("test_ElasticDataStore")
@Scope(BeanDefinition.SCOPE_PROTOTYPE)
open class ElasticDataStore : DataStore {
    private var name: String? = null

    override fun getName(): String? {
        return name
    }

    override fun setName(name: String?) {
        this.name = name
    }

    override fun load(context: LoadContext<*>): Any? {
        return loadList(context).firstOrNull()
    }

    override fun loadList(context: LoadContext<*>): MutableList<Any> {

        return mutableListOf()
    }

    override fun getCount(context: LoadContext<*>): Long {
        return loadList(context).size.toLong()
    }

    override fun save(context: SaveContext): MutableSet<*> {
        throw UnsupportedOperationException("Can not save Index")
    }

    override fun loadValues(context: ValueLoadContext): MutableList<KeyValueEntity>? {
        return null
    }

    override fun getCount(context: ValueLoadContext): Long {
        return 0
    }

}