package com.company.test.entity

import io.jmix.core.DataManager
import io.jmix.core.entity.annotation.JmixGeneratedValue
import io.jmix.core.metamodel.annotation.DependsOnProperties
import io.jmix.core.metamodel.annotation.InstanceName
import io.jmix.core.metamodel.annotation.JmixEntity
import io.jmix.core.metamodel.annotation.JmixProperty
import jakarta.annotation.PostConstruct
import jakarta.persistence.Column
import jakarta.persistence.Entity
import jakarta.persistence.Id
import jakarta.persistence.Table
import jakarta.validation.constraints.NotNull
import java.util.*

@JmixEntity
@Table(name = "JT_TEST_ENTITY")
@Entity(name = "jt_TestEntity")
open class TestEntity {
    @JmixGeneratedValue
    @Column(name = "ID", nullable = false)
    @Id
    var id: UUID? = null

    @NotNull
    @InstanceName
    @Column(name = "NAME")
    var name: String? = null

    @NotNull
    @Column(name = "BOOL_VAR", nullable = false)
    var boolVar: Boolean? = false

    @Transient
    @JmixProperty
    var testDto: TestDto? = null

    @Transient
    @JmixProperty
    var testDto2: TestDto? = null

    @JmixProperty
    @DependsOnProperties("boolVar")
    fun getTestDtoForGrid(): TestDto? {
        return if (boolVar == true) {
            testDto
        } else {
            testDto2
        }
    }

    @PostConstruct
    fun postConstruct(dataManager: DataManager) {
        testDto = dataManager.create(TestDto::class.java)
        testDto2 = dataManager.create(TestDto::class.java)
    }

}