package com.company.test.sys

import com.vaadin.flow.server.CustomizedSystemMessages
import com.vaadin.flow.server.ServiceInitEvent
import com.vaadin.flow.server.SystemMessagesProvider
import io.jmix.core.CoreProperties
import io.jmix.core.JmixModules
import io.jmix.core.Resources
import io.jmix.flowui.exception.UiExceptionHandlers
import io.jmix.flowui.sys.JmixServiceInitListener
import io.jmix.flowui.view.ViewRegistry
import org.springframework.context.annotation.Primary
import org.springframework.stereotype.Component

class CustomInitServiceListener(
    viewRegistry: ViewRegistry,
    uiExceptionHandlers: UiExceptionHandlers,
    coreProperties: CoreProperties,
    modules: JmixModules,
    resources: Resources
) : JmixServiceInitListener(viewRegistry, uiExceptionHandlers, coreProperties, modules, resources) {

    override fun serviceInit(event: ServiceInitEvent) {
        super.serviceInit(event)

        event.source.systemMessagesProvider = SystemMessagesProvider {
            val messages = CustomizedSystemMessages()
            messages.sessionExpiredCaption = "Session expired Message update"
            messages.sessionExpiredMessage = "Take note of any unsaved data, and click here or press ESC key to continue. Message update"
            messages
        }
    }
}